/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Borland-compatible get/setftime functions
*
****************************************************************************/

#include <dos.h>
#include <time.h>

#ifndef COUNTRY
struct ftime {
    unsigned ft_tsec  : 5;  /* Two seconds */
    unsigned ft_min   : 6;  /* Minutes */
    unsigned ft_hour  : 5;  /* Hours */
    unsigned ft_day   : 5;  /* Days */
    unsigned ft_month : 4;  /* Months */
    unsigned ft_year  : 7;  /* Year - 1980 */
};
#endif

union borftime {
    struct {
        unsigned time;
        unsigned date;
    } msc_time;
    struct ftime bc_time;
};


_WCRTLINK int getftime ( int handle, struct ftime *ftimep )
{
      union borftime ftm;
      
      if( _dos_getftime( handle,
                          ( unsigned short * )&ftm.msc_time.date,
                          ( unsigned short * )&ftm.msc_time.time )
              == 0 )
      {
            *ftimep = ftm.bc_time;
      } else return( -1 );
      return( 0 );
}

_WCRTLINK int setftime ( int handle, struct ftime *ftimep )
{
      union borftime ftm;
      
      ftm.bc_time = *ftimep;
      return( ( _dos_setftime( handle,
                               ftm.msc_time.date,
                               ftm.msc_time.time ) == 0 ) ? 0 : -1 );
}

