/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Borland-compatible ioctl function
*
****************************************************************************/

#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <dos.h>

_WCRTLINK int ioctl( int handle, int cmd, ... )
{
    union REGS r;
    
    cmd |= 0x4400;
    r.x.bx = handle;
    r.x.ax = 0x4400 | cmd;

    if( cmd == 0 ) {
        intdos( &r, &r );
	}
    
    if( cmd == 1 ) {
        va_list l;
        void *argdx;
        
        va_start( l, cmd );
        argdx = va_arg( l, void * );
        va_end( l );
        
        r.x.dx = ( short )argdx;
        
        intdos( &r, &r );
    }
    
    if( cmd > 1 && cmd < 6 ) {
        struct SREGS  s;
        va_list       l;
        void          *argdx;
        int           argcx;
        
        va_start( l, cmd );
        argdx = va_arg( l, void * );
        argcx = va_arg( l, unsigned char );
        va_end( l );
        
        if( cmd == 4 || cmd == 5 ) r.h.bl = argcx;
        else r.x.cx = argcx;
        
        s.ds = FP_SEG( argdx );
        r.x.dx = FP_OFF( argdx );
        intdosx( &r, &r, &s );
        argdx = ( void * )MK_FP( s.ds, r.x.dx );
        return( ( r.x.cflag ) ? -1 : r.x.ax );
    }
    
    if( cmd == 6 || cmd == 7 ) {
        intdos( &r, &r );
        return( ( r.x.cflag ) ? -1 : r.h.al );
    }
    
    if( cmd == 8 ) {
        r.x.bx = 0;
        r.h.bl = handle;
        intdos( &r, &r );
        return( ( r.x.cflag ) ? -1 : r.x.ax );
    }
    
    if( cmd == 11 ) {
        r.x.bx = 0;
        r.x.dx = handle;
        intdos( &r, &r );
        return( ( r.x.cflag ) ? r.x.ax : 0 );
    }

    if( cmd == 0 || cmd == 1 ) return( ( r.x.cflag ) ? -1 : r.x.dx );
    
    errno = EINVAL;
    return( -1 );
}

